## mysql-8.4 8.4.7

=== debian/changelog ===
mysql-8.4 (8.4.7-0ubuntu2) resolute; urgency=medium

  * d/rules: Skip build tests failing on amd64v3 (LP: #2130339)

 -- Lena Voytek <lena.voytek@canonical.com>  Thu, 30 Oct 2025 10:14:24 -0400

mysql-8.4 (8.4.7-0ubuntu1) resolute; urgency=medium

  * Import upstream version 8.4.7 to fix security issues
    - https://www.oracle.com/security-alerts/cpuoct2025.html#AppendixMSQL
    - CVE-2025-53040 CVE-2025-53042 CVE-2025-53044 CVE-2025-53045
      CVE-2025-53053 CVE-2025-53054 CVE-2025-53062 CVE-2025-53069
    Upstream release notes:
    - https://dev.mysql.com/doc/relnotes/mysql/8.4/en/news-8-4-7.html
  * Remove suggests packages no longer in debian and update recommends
  * Update it.po translation file - thanks to Luca Monducci

  [ Zachary Raines ]
  * Update postinst to ignore lost+found directory (LP: #2129196)

 -- Lena Voytek <lena.voytek@canonical.com>  Mon, 27 Oct 2025 09:08:48 -0400
