## mysql-8.4 8.4.8

=== debian/changelog ===
mysql-8.4 (8.4.8-0ubuntu1) resolute; urgency=medium

  * Import upstream version 8.4.8 to fix security issues
    - https://www.oracle.com/security-alerts/cpujan2026.html#AppendixMSQL
    - CVE-2025-6965 CVE-2025-9230 CVE-2026-21936 CVE-2026-21937
      CVE-2026-21941 CVE-2026-21948 CVE-2026-21964 CVE-2026-21968
    Upstream release notes:
    - https://dev.mysql.com/doc/relnotes/mysql/8.4/en/news-8-4-8.html
  * d/rules: Remove amd64v3-specific unit test exceptions, fixed upstream

 -- Lena Voytek <lena.voytek@canonical.com>  Sat, 24 Jan 2026 17:57:48 -0500

mysql-8.4 (8.4.7-0ubuntu3) resolute; urgency=medium

  * No-change rebuild for icu soname.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 02 Dec 2025 22:49:23 +0100
