=== debian/rules ===
--- 
+++ 
@@ -161,14 +161,6 @@
 else ifeq ($(BUILD_WITHOUT_SERVER),OFF)
 	touch $(builddir)/mysql-test/skiplist
 
-ifeq ($(ARCH_VARIANT),amd64v3)
-	# Tests failing on amd64v3
-	echo "main.subquery_sj_all_bka_nobnl			: BUG#00000 -  Nested loop left join cost off by .1 on amd64v3" >> $(builddir)/mysql-test/skiplist
-	echo "main.subquery_sj_mat_bka_nobnl			: BUG#00000 -  Nested loop left join cost off by .1 on amd64v3" >> $(builddir)/mysql-test/skiplist
-	echo "main.myisam_explain_json_non_select_all	: BUG#00000 -  JSON explain error on amd64v3" >> $(builddir)/mysql-test/skiplist
-	echo "main.myisam_explain_json_non_select_none	: BUG#00000 -  JSON explain error on amd64v3" >> $(builddir)/mysql-test/skiplist
-endif
-
 	# Tests that require more resources than LP provides at build time
 	echo "main.log_state					: BUG#00000 -  Requires additional resources" >> $(builddir)/mysql-test/skiplist
 	echo "main.histograms					: BUG#00000 -  Requires additional resources" >> $(builddir)/mysql-test/skiplist
@@ -218,3 +210,23 @@
 		-Xusr/share/man \
 		-Xusr/share/mysql/mysql.server \
 		-Xmysql.info
+	dh_apparmor -pmysql-server --profile-name=usr.sbin.mysqld
+
+override_dh_missing:
+	dh_missing --fail-missing \
+		-Xusr/share/man \
+		-Xusr/share/mysql/mysql.server \
+		-Xmysql.info
+
+override_dh_installsystemd:
+	dh_installsystemd --name=mysql --no-restart-after-upgrade
+
+override_dh_installcron-arch:
+	dh_installcron --name mysql-server
+
+get-orig-source:
+	uscan --force-download --verbose
+
+%:
+	dh $@ --parallel
+
